/**
 * 	
 * Copyright 2013 Pagecrumb
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * 	   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *  
 */
package com.mungoae.serializer;

import com.mungoae.common.SerializationException;

/**
 * Provides a implementation agnostic object serialization
 * interface. 
 * 
 * @author Kerby Martino (kerbymart@gmail.com)
 *
 */
public interface ObjectSerializer { 
	public String serialize(Object obj) throws SerializationException; 
	public Object deserialize(String obj) throws SerializationException;
}
